//+------------------------------------------------------------------+
//|                                                  MouseCanvas.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas.mqh> //https://www.mql5.com/ru/code/22164
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() {
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   return(rates_total);
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   static datetime t[];
   static double  pr[];
   static uint   clr[];
   static int j=0;
   if (id == CHARTEVENT_MOUSE_MOVE) {
      if (j%100==0) {
         ArrayResize(t,j+101);
         ArrayResize(pr,j+101);
         ArrayResize(clr,j+101);
      }
      clr[j]=ARGB(255,rand()%255,rand()%255,rand()%255);
      if (j>0) Canvas.Line((int)Canvas.X(t[j-1]),(int)Canvas.Y(pr[j-1]),_MouseX,_MouseY, clr[j]);
      t[j]=Canvas.TimePos(double(_MouseX));
      pr[j]=Canvas.Price(_MouseY);
      Canvas.Update();
      j++;
   }
   if (id==CHARTEVENT_CHART_CHANGE) {
      Canvas.Erase(0x00FFFFFF);
      for (int i=0; i<j-1; i++)
         Canvas.Line((int)Canvas.X(t[i]),(int)Canvas.Y(pr[i]),(int)Canvas.X(t[i+1]),(int)Canvas.Y(pr[i+1]), clr[i+1]);
      Canvas.Update();
   }
}
//+------------------------------------------------------------------+
